<?php

/*
		Gestion de cartes
		
        Class for table : marker.

        10/13/2022 12:52

        monmail@fai.com - 2022
        
        Licence libre etc ...

        Usage examples :

        <?php

            include_once("classdir/dbconnect.php);
            include_once("classdir/class_marker.php);

            // Class instance
            $mymarker = marker( $db );

            // Select all reccords :
            $results = $mymarker->selectAll();
            foreach($results as $row) {
                print_r($row);
            } 

            // Select reccord #12 :
            $id = 12;
            $row = $mymarker->select($id);
            print_r($row);

        ?>

*/
class _marker {
      
    public $db;
    public $lasterror="";
    public $lastInsertId=-1;
    public $count = 0;
  
    /*
        Initialise object with dbHanler.
                
    */    
    function __construct( $db ) {
        $this->db = $db;
    }

    /*
        Select one reccord from marker.
        
        parameters : $id (reccord id).
        return : associative array of reccord.
    */
    function select($id) {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.key as 'a.key',
			a.name as 'a.name',
			a.type as 'a.type',
			a.description as 'a.description',
			a.lat as 'a.lat',
			a.lon as 'a.lon',
			a.alt as 'a.alt',
			a.url as 'a.url',
			a.iconurl as 'a.iconurl',
			a.photoprefix as 'a.photoprefix',
			a.datemaj as 'a.datemaj',
			a.category_id as 'a.category_id',
			a.datecreated as 'a.datecreated',

 			b1.id as 'b1.id', 
 			b1.name as 'b1.name', 
 			b1.valid as 'b1.valid', 
 			b1.checked as 'b1.checked', 
 			b1.externaldata as 'b1.externaldata', 
 			b1.form as 'b1.form', 
 			b1.iconurl as 'b1.iconurl', 
 			b1.owner as 'b1.owner', 
 			b1.map_id as 'b1.map_id' 

		from marker a 
 			left outer join category b1 on b1.id =  a.category_id 

		where a.id = :id; 
			";

        try {        		

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$idkeyname.')';
            return false;
        }
    }

    function selectPrev($id) {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.key as 'a.key',
			a.name as 'a.name',
			a.type as 'a.type',
			a.description as 'a.description',
			a.lat as 'a.lat',
			a.lon as 'a.lon',
			a.alt as 'a.alt',
			a.url as 'a.url',
			a.iconurl as 'a.iconurl',
			a.photoprefix as 'a.photoprefix',
			a.datemaj as 'a.datemaj',
			a.category_id as 'a.category_id',
			a.datecreated as 'a.datecreated',

 			b1.id as 'b1.id', 
 			b1.name as 'b1.name', 
 			b1.valid as 'b1.valid', 
 			b1.checked as 'b1.checked', 
 			b1.externaldata as 'b1.externaldata', 
 			b1.form as 'b1.form', 
 			b1.iconurl as 'b1.iconurl', 
 			b1.owner as 'b1.owner', 
 			b1.map_id as 'b1.map_id' 

		from marker a 
 			left outer join category b1 on b1.id =  a.category_id 

		where a.id =  (SELECT id FROM marker WHERE id < :id ORDER BY id DESC LIMIT 1) ; 
			";

        try {        		

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$idkeyname.')';
            return false;
        }
    }


    function selectNext($id) {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.key as 'a.key',
			a.name as 'a.name',
			a.type as 'a.type',
			a.description as 'a.description',
			a.lat as 'a.lat',
			a.lon as 'a.lon',
			a.alt as 'a.alt',
			a.url as 'a.url',
			a.iconurl as 'a.iconurl',
			a.photoprefix as 'a.photoprefix',
			a.datemaj as 'a.datemaj',
			a.category_id as 'a.category_id',
			a.datecreated as 'a.datecreated',

 			b1.id as 'b1.id', 
 			b1.name as 'b1.name', 
 			b1.valid as 'b1.valid', 
 			b1.checked as 'b1.checked', 
 			b1.externaldata as 'b1.externaldata', 
 			b1.form as 'b1.form', 
 			b1.iconurl as 'b1.iconurl', 
 			b1.owner as 'b1.owner', 
 			b1.map_id as 'b1.map_id' 

		from marker a 
 			left outer join category b1 on b1.id =  a.category_id 

		where a.id =  (SELECT id FROM marker WHERE id > :id ORDER BY id ASC LIMIT 1) ; 
			";

        try {        		

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$idkeyname.')';
            return false;
        }
    }

    /*
        Select all reccords from marker  (with default order).
        
        parameters : None
        return : associative array of reccords.
    */
    function selectAll() {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.key as 'a.key',
			a.name as 'a.name',
			a.type as 'a.type',
			a.description as 'a.description',
			a.lat as 'a.lat',
			a.lon as 'a.lon',
			a.alt as 'a.alt',
			a.url as 'a.url',
			a.iconurl as 'a.iconurl',
			a.photoprefix as 'a.photoprefix',
			a.datemaj as 'a.datemaj',
			a.category_id as 'a.category_id',
			a.datecreated as 'a.datecreated',

 			b1.id as 'b1.id',
 			b1.name as 'b1.name',
 			b1.valid as 'b1.valid',
 			b1.checked as 'b1.checked',
 			b1.externaldata as 'b1.externaldata',
 			b1.form as 'b1.form',
 			b1.iconurl as 'b1.iconurl',
 			b1.owner as 'b1.owner',
 			b1.map_id as 'b1.map_id'

		from marker a 
 			left outer join category b1 on b1.id =  a.category_id 

		;    
                ";

        try {        

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);           
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage();
            $this->count = 0;
            return false;
        }
    }

    /*
        Update marker 
        
        parameters : $id (reccord id) and fields list values.
        return : True if no error.
    */
    function update( $id, $key,$name,$type,$description,$lat,$lon,$alt,$url,$iconurl,$photoprefix,$datemaj,$category_id,$datecreated ) {

        $this->lasterror="";        

		if ($key == '') $key = null;
		if ($name == '') $name = null;
		if ($type == '') $type = null;
		if ($description == '') $description = null;
		if ($lat == '') $lat = null;
		if ($lon == '') $lon = null;
		if ($alt == '') $alt = null;
		if ($url == '') $url = null;
		if ($iconurl == '') $iconurl = null;
		if ($photoprefix == '') $photoprefix = null;
		if ($datemaj == '') $datemaj = null;
		if ($category_id == '') $category_id = null;
		if ($datecreated == '') $datecreated = null;
		

        if ($this->checkValue( array( 
		$key => '',
		$name => '',
		$type => '',
		$description => '',
		$lat => '',
		$lon => '',
		$alt => '',
		$url => '',
		$iconurl => '',
		$photoprefix => '',
		$datemaj => '',
		$category_id => '',
		$datecreated => ''

) ) == false )
        {
            $this->lasterror="Check fields false";        
            return false;
        }

        $sqlSt="
		update marker set
			key = :key,
			name = :name,
			type = :type,
			description = :description,
			lat = :lat,
			lon = :lon,
			alt = :alt,
			url = :url,
			iconurl = :iconurl,
			photoprefix = :photoprefix,
			datemaj = :datemaj,
			category_id = :category_id,
			datecreated = :datecreated

		where id = :id; 
            ";

        try {        
            
            $stmt = $this->db->prepare($sqlSt);
            
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);

			$stmt->bindParam(':key', $key, PDO::PARAM_STR); 
			$stmt->bindParam(':name', $name, PDO::PARAM_STR); 
			$stmt->bindParam(':type', $type, PDO::PARAM_INT); 
			$stmt->bindParam(':description', $description, PDO::PARAM_STR); 
			$stmt->bindParam(':lat', $lat, PDO::PARAM_STR); 
			$stmt->bindParam(':lon', $lon, PDO::PARAM_STR); 
			$stmt->bindParam(':alt', $alt, PDO::PARAM_STR); 
			$stmt->bindParam(':url', $url, PDO::PARAM_STR); 
			$stmt->bindParam(':iconurl', $iconurl, PDO::PARAM_STR); 
			$stmt->bindParam(':photoprefix', $photoprefix, PDO::PARAM_STR); 
			$stmt->bindParam(':datemaj', $datemaj, PDO::PARAM_STR); 
			$stmt->bindParam(':category_id', $category_id, PDO::PARAM_INT); 
			$stmt->bindParam(':datecreated', $datecreated, PDO::PARAM_STR); 
 
            $stmt->execute();             
            
            if ($stmt->rowCount() == 0) {
				$this->lasterror = 'Erreur Sql update '.'  (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>key</b> = [$key],<b>name</b> = [$name],<b>type</b> = [$type],<b>description</b> = [$description],<b>lat</b> = [$lat],<b>lon</b> = [$lon],<b>alt</b> = [$alt],<b>url</b> = [$url],<b>iconurl</b> = [$iconurl],<b>photoprefix</b> = [$photoprefix],<b>datemaj</b> = [$datemaj],<b>category_id</b> = [$category_id],<b>datecreated</b> = [$datecreated]";
				
				return false;
			}   
			         
            return true;

        } catch (Exception $e) {            
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>key</b> = [$key],<b>name</b> = [$name],<b>type</b> = [$type],<b>description</b> = [$description],<b>lat</b> = [$lat],<b>lon</b> = [$lon],<b>alt</b> = [$alt],<b>url</b> = [$url],<b>iconurl</b> = [$iconurl],<b>photoprefix</b> = [$photoprefix],<b>datemaj</b> = [$datemaj],<b>category_id</b> = [$category_id],<b>datecreated</b> = [$datecreated]";  
            return false;
        }

    }

    /*
        Insert new reccord into marker.
        
        Parameters : fields values list.
        return : True if no error.
    */
    function insert( $key,$name,$type,$description,$lat,$lon,$alt,$url,$iconurl,$photoprefix,$datemaj,$category_id,$datecreated ) {

        $this->lasterror="";
        $this->lastInsertId = -1;

		if ($key == '') $key = null;
		if ($name == '') $name = null;
		if ($type == '') $type = null;
		if ($description == '') $description = null;
		if ($lat == '') $lat = null;
		if ($lon == '') $lon = null;
		if ($alt == '') $alt = null;
		if ($url == '') $url = null;
		if ($iconurl == '') $iconurl = null;
		if ($photoprefix == '') $photoprefix = null;
		if ($datemaj == '') $datemaj = null;
		if ($category_id == '') $category_id = null;
		if ($datecreated == '') $datecreated = null;
		
		
        if ($this->checkValue( array( 
		$key => '',
		$name => '',
		$type => '',
		$description => '',
		$lat => '',
		$lon => '',
		$alt => '',
		$url => '',
		$iconurl => '',
		$photoprefix => '',
		$datemaj => '',
		$category_id => '',
		$datecreated => ''

) ) == false )
        {
            $this->lasterror="Check fields error";        
            return false;
        }

        $sqlSt="
		insert into marker (
		key,
		name,
		type,
		description,
		lat,
		lon,
		alt,
		url,
		iconurl,
		photoprefix,
		datemaj,
		category_id,
		datecreated
 
			)
		values (
		:key, 
		:name, 
		:type, 
		:description, 
		:lat, 
		:lon, 
		:alt, 
		:url, 
		:iconurl, 
		:photoprefix, 
		:datemaj, 
		:category_id, 
		:datecreated 
 
			);    
            ";

        try {        

            $stmt = $this->db->prepare($sqlSt);               
			
			$stmt->bindParam(':key', $key, PDO::PARAM_STR); 
			$stmt->bindParam(':name', $name, PDO::PARAM_STR); 
			$stmt->bindParam(':type', $type, PDO::PARAM_INT); 
			$stmt->bindParam(':description', $description, PDO::PARAM_STR); 
			$stmt->bindParam(':lat', $lat, PDO::PARAM_STR); 
			$stmt->bindParam(':lon', $lon, PDO::PARAM_STR); 
			$stmt->bindParam(':alt', $alt, PDO::PARAM_STR); 
			$stmt->bindParam(':url', $url, PDO::PARAM_STR); 
			$stmt->bindParam(':iconurl', $iconurl, PDO::PARAM_STR); 
			$stmt->bindParam(':photoprefix', $photoprefix, PDO::PARAM_STR); 
			$stmt->bindParam(':datemaj', $datemaj, PDO::PARAM_STR); 
			$stmt->bindParam(':category_id', $category_id, PDO::PARAM_INT); 
			$stmt->bindParam(':datecreated', $datecreated, PDO::PARAM_STR); 
 

            $stmt->execute();     
            $this->lastInsertId = $this->db->lastInsertId(); 
            
            if ($stmt->rowCount() == 0) {
				$this->lasterror = 'Erreur Sql insert'.'  (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>key</b> = [$key],<b>name</b> = [$name],<b>type</b> = [$type],<b>description</b> = [$description],<b>lat</b> = [$lat],<b>lon</b> = [$lon],<b>alt</b> = [$alt],<b>url</b> = [$url],<b>iconurl</b> = [$iconurl],<b>photoprefix</b> = [$photoprefix],<b>datemaj</b> = [$datemaj],<b>category_id</b> = [$category_id],<b>datecreated</b> = [$datecreated]";
				return false;
			}              
                   
            return true;

        } catch (Exception $e) {
             $this->lasterror = $e->getMessage().'  (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>key</b> = [$key],<b>name</b> = [$name],<b>type</b> = [$type],<b>description</b> = [$description],<b>lat</b> = [$lat],<b>lon</b> = [$lon],<b>alt</b> = [$alt],<b>url</b> = [$url],<b>iconurl</b> = [$iconurl],<b>photoprefix</b> = [$photoprefix],<b>datemaj</b> = [$datemaj],<b>category_id</b> = [$category_id],<b>datecreated</b> = [$datecreated]";
            return false;
        }
    }

    /*
        Delete one reccord from marker.
        
        parameters : $id (reccord id).
        return : True if no error.
    */
    function delete($id) {

        $this->lasterror="";

        $sqlSt="
		delete from marker             
		where id = :id; 
            ";   
     
        try {        

            $stmt = $this->db->prepare($sqlSt);  
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute();        
            
			if ($stmt->rowCount() == 0) {
				$this->lasterror = "Erreur Sql delete ".' (<b>Id</b> ='.$id.')';       
				return false;
			}              

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b>='.$id.')';
            return false;
        }
        return true;
    }

    /*
        Get id min, id max, record count from marker  
        
        parameters : None
        return : count value or False in case of error
    */
	function getCount() {
		
        $this->lasterror="";

        $sqlSt="
		select min(id) as minid, max(id) as maxid, count(*) as count 
		from marker 
                ";

        try {        

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC); 
            return $results[0];          

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage();
            return array( 'minid' => -1, 'maxid' => -1, 'count' => -1);
        }
        		
		//return $this->count;
		return $results[0];
	}




	public $colmeta = [
	'a.id' => array (
		'metades' => "Identifiant",
		'sortformat' => "{{sortformat}}",
		'listlen' => 4,
		'listlib' => 'Id',
		'listlink' => 'on',
		'selectlen' => 4,
		'selectlib' => 'Id',
		'selectlink' => 'on',
		'selectdisplay' => '',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => '', 
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 

		),
	'a.key' => array ( 
		'metades' => "Clé logique",
		'sortformat' => "", 
		'listlen' => 12,
		'listlib' => 'Clé' , 
		'listlink' => '',
		'selectlen' => 12,
		'selectlib' => 'Clé' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.name' => array ( 
		'metades' => "Nom du marker (titre)",
		'sortformat' => "", 
		'listlen' => 32,
		'listlib' => 'Nom' , 
		'listlink' => '',
		'selectlen' => 32,
		'selectlib' => 'Nom' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.type' => array ( 
		'metades' => "Type d´objet (1=marker ..)",
		'sortformat' => "", 
		'listlen' => 4,
		'listlib' => 'Type' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'Type' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.description' => array ( 
		'metades' => "Description",
		'sortformat' => "", 
		'listlen' => 20,
		'listlib' => 'Description' , 
		'listlink' => '',
		'selectlen' => 12,
		'selectlib' => 'Description' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.lat' => array ( 
		'metades' => "Lattitude",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'Lattitude' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'Lattitude' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.lon' => array ( 
		'metades' => "Longitude",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'Longitude' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'Longitude' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.alt' => array ( 
		'metades' => "Altitude",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'Altitude' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'Altitude' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.url' => array ( 
		'metades' => "Url associé à l´objet",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'Url' , 
		'listlink' => '',
		'selectlen' => 12,
		'selectlib' => 'Url' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.iconurl' => array ( 
		'metades' => "Url de l´icône",
		'sortformat' => "", 
		'listlen' => 12,
		'listlib' => 'Url icône' , 
		'listlink' => '',
		'selectlen' => 12,
		'selectlib' => 'Url icône' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'urlpic',
		'listdisplaywidth' => '50', 
		'listdisplayheight' => '50' 
),
	'a.photoprefix' => array ( 
		'metades' => "Préfixe des photos associées au point",
		'sortformat' => "", 
		'listlen' => 12,
		'listlib' => 'Préfixe photos' , 
		'listlink' => '',
		'selectlen' => 12,
		'selectlib' => 'Préfixe photos' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.datemaj' => array ( 
		'metades' => "Date de mise à jour des données",
		'sortformat' => "", 
		'listlen' => 12,
		'listlib' => 'Mise à jour' , 
		'listlink' => '',
		'selectlen' => 12,
		'selectlib' => 'Mise à jour' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.category_id' => array ( 
		'metades' => "Couche",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'Couche' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'Couche' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.datecreated' => array ( 
		'metades' => "Date de création",
		'sortformat' => "date", 
		'listlen' => 4,
		'listlib' => 'Modifié le' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'Modifié le' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),

 	'b1.id' => array (  // Category
		'metades' => "",
		'sortformat' => "",
		'listlen' => 8,
		'listlib' => 'id', 
		'listlink' => '' ,
		'selectlen' => 8,
		'selectlib' => 'id', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.name' => array (  // Category
		'metades' => "",
		'sortformat' => "",
		'listlen' => 8,
		'listlib' => 'name', 
		'listlink' => '' ,
		'selectlen' => 8,
		'selectlib' => 'name', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.valid' => array (  // Category
		'metades' => "",
		'sortformat' => "",
		'listlen' => 8,
		'listlib' => 'valid', 
		'listlink' => '' ,
		'selectlen' => 8,
		'selectlib' => 'valid', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.checked' => array (  // Category
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'checked', 
		'listlink' => '' ,
		'selectlen' => 8,
		'selectlib' => 'checked', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.externaldata' => array (  // Category
		'metades' => "Données externes à la base de données",
		'sortformat' => "",
		'listlen' => 8,
		'listlib' => 'externaldata', 
		'listlink' => '' ,
		'selectlen' => 8,
		'selectlib' => 'externaldata', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.form' => array (  // Category
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'form', 
		'listlink' => '' ,
		'selectlen' => 8,
		'selectlib' => 'form', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.iconurl' => array (  // Category
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'iconurl', 
		'listlink' => '' ,
		'selectlen' => 8,
		'selectlib' => 'iconurl', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.owner' => array (  // Category
		'metades' => "",
		'sortformat' => "",
		'listlen' => 0,
		'listlib' => 'owner', 
		'listlink' => '' ,
		'selectlen' => 8,
		'selectlib' => 'owner', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
), 
 	'b1.map_id' => array (  // Category
		'metades' => "",
		'sortformat' => "",
		'listlen' => 8,
		'listlib' => 'map_id', 
		'listlink' => '' ,
		'selectlen' => 8,
		'selectlib' => 'map_id', 
		'selectlink' => '{{fkselectlink}}',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
) 
			
	];

    /*
        Get field property value
        
        Parameters : field name and property name.
        return : value of property.
    */

	function getMeta( $fieldkey , $metakey ) {
		return $this->colmeta [$fieldkey][$metakey];
	}

    /*
        Get labels for list table header.
        
        Parameters : None.
        return : String.
    */

	function getTableHeaderList() {		
		
		$labelsStr ='';
		
		foreach (  $this->colmeta as $k => $v) {
			if ( $v['listlen'] > 0 ) 
				$labelsStr = $labelsStr.'<th title="'.$v['metades'].'" >'.$v['listlib'] .'</th>'."\n";
		}				
		return $labelsStr;
	}
	
	function getTableFieldLenList( $field ) {		
		
		return $this->colmeta[$field]['listlen'];
	}

	function getTableFieldLinkList( $field ) {		
		
		return $this->colmeta[$field]['listlink'];
	}

    /*
        Get labels for select table header.
        
        Parameters : None.
        return : String.
    */

	function getTableHeaderSelect() {		
		
		$labelsStr ='';
		
		foreach (  $this->colmeta as $k => $v) {
			if ( $v['selectlen'] > 0 ) 
				$labelsStr = $labelsStr.'<th title="'.$v['metades'].'" >'.$v['selectlib'] .'</th>'."\n";
		}				
		return $labelsStr;
	}
	
	function getTableFieldLenSelect( $field ) {		
		
		return $this->colmeta[$field]['selectlen'];
	}

	function getTableFieldLinkSelect( $field ) {		
		
		return $this->colmeta[$field]['selectlink'];
	}

	
    /*
        Check user input values for marker.
        
        Parameters : array of fields with regexp  paterns. ex: array( $nom =>'^(?!\s*$).+' , $icone => '')
        return : False if at last one regexp does not match.
    */
    function checkValue( $arrayCheck ) {

        $indexfield=1;
        foreach ( $arrayCheck as $value => $pattern) {

            if ($pattern=='') continue;

            $pattern='/'.$pattern.'/';

            if (!preg_match($pattern, $value)) {
                $this->lasterror = "Erreur champ #".$indexfield. '. Valeur:['.$value.']';
                return false;                
            }

            $indexfield+=1;

        }

        return true;
    }

} // end class

?>
